#!/usr/bin/env python
#########################################################
#              RETicker v. 0.4.5pre
# a programm to display xml-formatted rss/rdf-feeds in
# a one line display
#########################################################
# please read Help.txt for contact information

#########################################################
# This file contains the classes storing and showing    #
# the actual news                                       #
#########################################################
from __future__ import generators

import rox
from rox import g, tasks

import os
import tool
import gobject

class IconBuffer:
	def __init__(self, filename= None, url = None, Stock = None):
		#g.Widget.__init__(self)
		self.__filename = filename
		self.__url = url
		self.__stock = Stock
		self.__iconset = None
		self.__pixbuf = None
		self.__pixbuf_active = None
	def get(self):
		if not(self.__iconset): self.__initialize()
		return self.__iconset
	def __set_image(self):
		#print "pixbuf " + str(self.__pixbuf)
		self.__iconset = g.IconSet(self.__pixbuf)
		tmp_pixbuf = self.__pixbuf.copy()
		tmp_pixbuf.saturate_and_pixelate(tmp_pixbuf, 5, g.FALSE)
		iconsrc = g.IconSource()
		iconsrc.set_pixbuf(tmp_pixbuf)
		iconsrc.set_state_wildcarded(g.FALSE)
		iconsrc.set_state(g.STATE_PRELIGHT)
		self.__iconset.add_source(iconsrc)
	def reinit(self, filename= None, url = None, Stock = None):
		self.__filename = filename
		self.__url = url
		self.__stock = stock
		self.__iconset = None
	def __initialize(self): ### trying to read icon from file
		if self.__filename: self.__set_from_file()
		elif self.__url: self.__set_from_url()
		else: self.__set_from_stock()
	def __set_from_file(self):
		if os.path.isfile(self.__filename):
			if self.__pixbuf: del self.__pixbuf; self.__pixbuf = None; gc.collect()
    			try:
				self.__pixbuf = g.gdk.pixbuf_new_from_file(self.__filename)
				self.__set_image()
			except (gobject.GError): return None
		else: return None
	def __set_from_url(self): tasks.Task(self.__set_from_uri_task())
	def __set_from_url_task(self):
		prog = tool.Win_ProgBar()
		prog.start_pulse()
		t = tool.urlretrieve(self.url, self.filename)
		yield None
		
		### wait a little bit till icon might be cached locally
		from news import HTTP_TIMEOUT
		for tick in range (0, HTTP_TIMEOUT):
			if t.Done() == 1: break
			yield tasks.TimeoutBlocker(1);
		prog.rem()
		if t.Status() == None:
			t.Kill()
			rox.alert("Icon could not retrieved from url:\n" + uri)
				
		#### now check if file is here and use it
		if os.path.isfile(self.filename): self.__initialize()
		### maybee this is a good place to leave a signal

class Stock_IconSets:
	def __init__(self):
		self.__sets = []
	def get(self, Stock):
		for set in self.__sets:
			if set['Stock'] == Stock: return set['iconset']
		new_iconset = self.__create_iconset_from_stock(Stock)
		self.__sets.append({'Stock' : Stock, 'iconset' : new_iconset})
		return new_iconset
	def __create_iconset_from_stock(self, Stock):
		tmp_ebuf = g.EventBox()
		pixbuf = tmp_ebuf.render_icon(Stock, g.ICON_SIZE_SMALL_TOOLBAR, "")
		iconset = g.IconSet(pixbuf)
		tmp_pixbuf = pixbuf.copy()
		tmp_pixbuf.saturate_and_pixelate(tmp_pixbuf, 5, g.FALSE)
		iconsrc = g.IconSource()
		iconsrc.set_pixbuf(tmp_pixbuf)
		iconsrc.set_state_wildcarded(g.FALSE)
		iconsrc.set_state(g.STATE_PRELIGHT)
		iconset.add_source(iconsrc)
		return iconset
